package com.diegol.profundiza;

import java.util.ArrayList;
import java.util.concurrent.ExecutionException;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ExpandableListView;
import android.widget.ExpandableListView.OnChildClickListener;
import android.widget.ExpandableListView.OnGroupClickListener;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.actionbarsherlock.app.SherlockFragment;

public class TabFragmentCategorias extends SherlockFragment {

	private ArrayList<String> categorias;

	private ArrayList<ArrayList<ArrayList<String>>> entradas;

	private ProgressDialog p;

	// Urls correspondientes a las entradas del blog que se van requiriendo
	private ArrayList<ArrayList<ArrayList<String>>> urls;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		entradas = new ArrayList<ArrayList<ArrayList<String>>>();
		urls = new ArrayList<ArrayList<ArrayList<String>>>();
		cargarDatos();
		LinearLayout l = (LinearLayout) inflater.inflate(
				R.layout.lay_categorias, container, false);
		ExpandableListView view = (ExpandableListView) l
				.findViewById(R.id.tab_categorias_expandable_listview);

		view.setOnGroupClickListener(new OnGroupClickListener() {

			@Override
			public boolean onGroupClick(ExpandableListView arg0, View arg1,
					int arg2, long arg3) {
				cargarDatos(arg2);
				return false;
			}
		});

		view.setOnChildClickListener(new OnChildClickListener() {

			@Override
			public boolean onChildClick(ExpandableListView parent, View v,
					int groupPosition, int childPosition, long id) {
				Intent i = new Intent(parent.getContext(),
						WebViewActivity.class);
				Bundle b = new Bundle();
				b.putString("url", urls.get(groupPosition).get(childPosition)
						.get(0));
				i.putExtras(b);
				parent.getContext().startActivity(i);
				return false;
			}
		});
		ExpandableAdapter e = new ExpandableAdapter(container.getContext(),
				categorias, entradas);
		view.setAdapter(e);
		container.findViewById(R.id.tab_inicio_leer_mas).setVisibility(
				View.INVISIBLE);
		container.findViewById(R.id.tab_inicio_leer_menos).setVisibility(
				View.INVISIBLE);
		return l;
	}

	public void cargarDatos() {
		// Hacer desde aqui una llamada a un AsyncTask para que cargue las
		// entradas de la categoria seleccionada
		categorias = new ArrayList<String>();
		categorias.add("	Educacion primaria");
		categorias.add("	Educacion secundaria");
		categorias.add("	Ciencias de la Naturaleza");
		categorias.add("	Conocimiento del Medio");
		categorias.add("	Fsica");
		categorias.add("	Informtica");
		categorias.add("	Qumica");
		categorias.add("	Sin categora");
		categorias.add("	Tecnologa");
		categorias.add("	Sociales, Geografa e Historia");
		categorias.add("	Matemticas");
		categorias.add("	Bachillerato");
		categorias.add("	Didctica");
		categorias.add("	Historia");
		categorias.add("	Lengua y Literatura");
		categorias.add("	Plstica");
		categorias.add("	Lenguas Extranjeras");
		categorias.add("	Organizacin");
		for (int i = 0; i < categorias.size(); i++) {
			entradas.add(new ArrayList<ArrayList<String>>());
			urls.add(new ArrayList<ArrayList<String>>());
		}
	}

	private class ExpandableAdapter extends BaseExpandableListAdapter {
		Context c;

		public ExpandableAdapter(Context c, ArrayList<String> categorias,
				ArrayList<ArrayList<ArrayList<String>>> entradas) {
			this.c = c;
		}

		@Override
		public ArrayList<String> getChild(int groupPosition, int childPosition) {
			return entradas.get(groupPosition).get(childPosition);
		}

		@Override
		public boolean areAllItemsEnabled() {
			return true;
		}

		@Override
		public long getChildId(int groupPosition, int childPosition) {
			return childPosition;
		}

		@Override
		public View getChildView(int groupPosition, int childPosition,
				boolean isLastChild, View convertView, ViewGroup parent) {
			// Devuelve el view del hijo en la posicin x. En este caso
			// devolver textview
			String child = (String) getChild(groupPosition, childPosition).get(
					0);
			if (convertView == null) {
				LayoutInflater infalInflater = (LayoutInflater) c
						.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = infalInflater.inflate(R.layout.fila_list_view,
						null);
			}
			TextView tv = (TextView) convertView
					.findViewById(R.id.filaTextView);
			tv.setText(child);
			return convertView;
		}

		@Override
		public int getChildrenCount(int groupPosition) {
			return entradas.get(groupPosition).size();
		}

		@Override
		public Object getGroup(int groupPosition) {
			return categorias.get(groupPosition);
		}

		@Override
		public int getGroupCount() {
			return categorias.size();
		}

		@Override
		public long getGroupId(int groupPosition) {
			return groupPosition;
		}

		@Override
		public View getGroupView(int groupPosition, boolean isExpanded,
				View convertView, ViewGroup parent) {
			String group = (String) getGroup(groupPosition);
			if (convertView == null) {
				LayoutInflater infalInflater = (LayoutInflater) c
						.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = infalInflater.inflate(
						R.layout.lay_grupos_expandlv, null);
			}
			TextView tv = (TextView) convertView
					.findViewById(R.id.TextViewGrupo);
			tv.setText(group);
			return convertView;
		}

		@Override
		public boolean hasStableIds() {
			return true;
		}

		@Override
		public boolean isChildSelectable(int groupPosition, int childPosition) {
			return true;
		}
	}

	public void cargarDatos(int groupPosition) throws IndexOutOfBoundsException {
		// Aqui va el codigo para aadir los titulos de las entradas
		// dependiendo de donde se haga click.
		showDialog();
		ArrayList<ArrayList<String>> datos = new ArrayList<ArrayList<String>>();
		switch (groupPosition) {

		// primaria
		case 0:
			if (entradas.get(0).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/primaria/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity()).execute(
								"http://www.profundiza.es/category/primaria/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(0).add(new ArrayList<String>());
					entradas.get(0).get(i).add(datos.get(0).get(i));
					urls.get(0).add(new ArrayList<String>());
					urls.get(0).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// secundaria
		case 1:
			if (entradas.get(1).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/secundaria/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/secundaria/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(1).add(new ArrayList<String>());
					entradas.get(1).get(i).add(datos.get(0).get(i));
					urls.get(1).add(new ArrayList<String>());
					urls.get(1).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// naturaleza
		case 2:
			if (entradas.get(2).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/naturaleza/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/naturaleza/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(2).add(new ArrayList<String>());
					entradas.get(2).get(i).add(datos.get(0).get(i));
					urls.get(2).add(new ArrayList<String>());
					urls.get(2).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// cono
		case 3:
			if (entradas.get(3).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/cono/").get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity()).execute(
								"http://www.profundiza.es/category/cono/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(3).add(new ArrayList<String>());
					entradas.get(3).get(i).add(datos.get(0).get(i));
					urls.get(3).add(new ArrayList<String>());
					urls.get(3).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// fisica
		case 4:
			if (entradas.get(4).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/fisica/").get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity()).execute(
								"http://www.profundiza.es/category/fisica/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(4).add(new ArrayList<String>());
					entradas.get(4).get(i).add(datos.get(0).get(i));
					urls.get(4).add(new ArrayList<String>());
					urls.get(4).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// informatica
		case 5:
			if (entradas.get(5).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/informatica/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/informatica/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(5).add(new ArrayList<String>());
					entradas.get(5).get(i).add(datos.get(0).get(i));
					urls.get(5).add(new ArrayList<String>());
					urls.get(5).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// quimica
		case 6:
			if (entradas.get(6).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/quimica/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity()).execute(
								"http://www.profundiza.es/category/quimica/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(6).add(new ArrayList<String>());
					entradas.get(6).get(i).add(datos.get(0).get(i));
					urls.get(6).add(new ArrayList<String>());
					urls.get(6).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// uncategorized
		case 7:
			if (entradas.get(7).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity())
							.execute(
									"http://www.profundiza.org/category/uncategorized/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/uncategorized/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(7).add(new ArrayList<String>());
					entradas.get(7).get(i).add(datos.get(0).get(i));
					urls.get(7).add(new ArrayList<String>());
					urls.get(7).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// tecnologia
		case 8:
			if (entradas.get(8).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/tecnologia/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/tecnologia/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(8).add(new ArrayList<String>());
					entradas.get(8).get(i).add(datos.get(0).get(i));
					urls.get(8).add(new ArrayList<String>());
					urls.get(8).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// sociales
		case 9:
			if (entradas.get(9).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/sociales/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity()).execute(
								"http://www.profundiza.es/category/sociales/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(9).add(new ArrayList<String>());
					entradas.get(9).get(i).add(datos.get(0).get(i));
					urls.get(9).add(new ArrayList<String>());
					urls.get(9).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// matematicas
		case 10:
			if (entradas.get(10).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/matematicas/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/matematicas/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(10).add(new ArrayList<String>());
					entradas.get(10).get(i).add(datos.get(0).get(i));
					urls.get(10).add(new ArrayList<String>());
					urls.get(10).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// bachillerato
		case 11:
			if (entradas.get(11).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/bachillerato/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/bachillerato/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(11).add(new ArrayList<String>());
					entradas.get(11).get(i).add(datos.get(0).get(i));
					urls.get(11).add(new ArrayList<String>());
					urls.get(11).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// didactica
		case 12:
			if (entradas.get(12).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/didactica/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity()).execute(
								"http://www.profundiza.es/category/didactica/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(12).add(new ArrayList<String>());
					entradas.get(12).get(i).add(datos.get(0).get(i));
					urls.get(12).add(new ArrayList<String>());
					urls.get(12).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// historia-2
		case 13:
			if (entradas.get(13).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/historia-2/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/historia-2/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(13).add(new ArrayList<String>());
					entradas.get(13).get(i).add(datos.get(0).get(i));
					urls.get(13).add(new ArrayList<String>());
					urls.get(13).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// lengua-y-literatura
		case 14:
			if (entradas.get(14).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity())
							.execute(
									"http://www.profundiza.org/category/lengua-y-literatura/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/lengua-y-literatura/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(14).add(new ArrayList<String>());
					entradas.get(14).get(i).add(datos.get(0).get(i));
					urls.get(14).add(new ArrayList<String>());
					urls.get(14).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// plastica
		case 15:
			if (entradas.get(15).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/plastica/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity()).execute(
								"http://www.profundiza.es/category/plastica/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(15).add(new ArrayList<String>());
					entradas.get(15).get(i).add(datos.get(0).get(i));
					urls.get(15).add(new ArrayList<String>());
					urls.get(15).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// lenguas-extranjeras
		case 16:
			if (entradas.get(16).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity())
							.execute(
									"http://www.profundiza.org/category/lenguas-extranjeras/")
							.get();
					if (datos.get(0).isEmpty()) {
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/lenguas-extranjeras/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(16).add(new ArrayList<String>());
					entradas.get(16).get(i).add(datos.get(0).get(i));
					urls.get(16).add(new ArrayList<String>());
					urls.get(16).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		// organizacion
		case 17:
			if (entradas.get(17).size() == 0) {
				try {
					datos = new ParseoAsincrono(getActivity()).execute(
							"http://www.profundiza.org/category/organizacion/")
							.get();
					if (datos.get(0).isEmpty()) {
						Log.e("ola", "k ase");
						datos = new ParseoAsincrono(getActivity())
								.execute(
										"http://www.profundiza.es/category/organizacion/")
								.get();
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
				for (int i = 0; i < datos.get(0).size(); i++) {
					entradas.get(17).add(new ArrayList<String>());
					entradas.get(17).get(i).add(datos.get(0).get(i));
					urls.get(17).add(new ArrayList<String>());
					urls.get(17).get(i).add(datos.get(1).get(i));
				}
			}
			break;

		default:
			Toast.makeText(getActivity(),
					"Si lee esto, por favor, avise al desarrollador",
					Toast.LENGTH_LONG).show();
			break;
		}
		dismissDialog();

	}

	private void showDialog() {
		p = ProgressDialog.show(getSherlockActivity(), "", "Cargando...", true,
				false);
	}

	private void dismissDialog() {
		if (p.isShowing()) {
			p.dismiss();
		}
	}
}
