package com.diegol.profundiza;

import java.util.ArrayList;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.ExpandableListView;
import android.widget.TextView;

import com.actionbarsherlock.app.SherlockFragment;

public class TabFragmentCentros extends SherlockFragment {

	ArrayList<String> provincias;
	ArrayList<ArrayList<ArrayList<String>>> centros;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		ExpandableListView view = (ExpandableListView) inflater.inflate(
				R.layout.lay_centros, container, false);
		cargarDatos();
		ExpandableAdapter e = new ExpandableAdapter(container.getContext(),
				provincias, centros);
		view.setAdapter(e);
		return view;
	}

	private class ExpandableAdapter extends BaseExpandableListAdapter {

		private ArrayList<String> groups;// provincias
		private ArrayList<ArrayList<ArrayList<String>>> children;// centros
		Context c;

		public ExpandableAdapter(Context c, ArrayList<String> provincias,
				ArrayList<ArrayList<ArrayList<String>>> centros) {
			this.c = c;
			this.groups = provincias;
			this.children = centros;
		}

		@Override
		public ArrayList<String> getChild(int groupPosition, int childPosition) {
			return children.get(groupPosition).get(childPosition);
		}

		@Override
		public boolean areAllItemsEnabled() {
			return true;
		}

		@Override
		public long getChildId(int groupPosition, int childPosition) {
			return childPosition;
		}

		@Override
		public View getChildView(int groupPosition, int childPosition,
				boolean isLastChild, View convertView, ViewGroup parent) {
			// Devuelve el view del hijo en la posicin x. En este caso
			// devolver textview
			String centro = (String) getChild(groupPosition, childPosition)
					.get(0);
			if (convertView == null) {
				LayoutInflater infalInflater = (LayoutInflater) c
						.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = infalInflater.inflate(R.layout.fila_list_view,
						null);
			}
			TextView tv = (TextView) convertView
					.findViewById(R.id.filaTextView);
			tv.setText(centro);
			return convertView;
		}

		@Override
		public int getChildrenCount(int groupPosition) {
			return children.get(groupPosition).size();
		}

		@Override
		public Object getGroup(int groupPosition) {
			return groups.get(groupPosition);
		}

		@Override
		public int getGroupCount() {
			return groups.size();
		}

		@Override
		public long getGroupId(int groupPosition) {
			return groupPosition;
		}

		@Override
		public View getGroupView(int groupPosition, boolean isExpanded,
				View convertView, ViewGroup parent) {
			String group = (String) getGroup(groupPosition);
			if (convertView == null) {
				LayoutInflater infalInflater = (LayoutInflater) c
						.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = infalInflater.inflate(
						R.layout.lay_grupos_expandlv, null);
			}
			TextView tv = (TextView) convertView
					.findViewById(R.id.TextViewGrupo);
			tv.setText(group);
			return convertView;
		}

		@Override
		public boolean hasStableIds() {
			return true;
		}

		@Override
		public boolean isChildSelectable(int groupPosition, int childPosition) {
			return true;
		}
	}

	public void cargarDatos() {
		provincias = new ArrayList<String>();
		centros = new ArrayList<ArrayList<ArrayList<String>>>();
		provincias.add("    Granada");
		provincias.add("    Crdoba");
		provincias.add("    Sevilla");
		provincias.add("    Jan");
		provincias.add("	Huelva");
		provincias.add("	Cdiz");
		provincias.add("	Almera");
		provincias.add("	Mlaga");
		centros.add(new ArrayList<ArrayList<String>>());
		centros.add(new ArrayList<ArrayList<String>>());
		centros.add(new ArrayList<ArrayList<String>>());
		centros.add(new ArrayList<ArrayList<String>>());
		centros.add(new ArrayList<ArrayList<String>>());
		centros.add(new ArrayList<ArrayList<String>>());
		centros.add(new ArrayList<ArrayList<String>>());
		centros.add(new ArrayList<ArrayList<String>>());
		/*centros.add(new ArrayList<ArrayList<String>>());
		centros.get(0).add(new ArrayList<String>());
		centros.get(0).get(0).add("   cent 1 gru 1");
		centros.get(0).add(new ArrayList<String>());
		centros.get(0).get(1).add("   cent 2 gru 1");
		centros.get(0).add(new ArrayList<String>());
		centros.get(0).get(2).add("   cent 3 gru 1");

		centros.add(new ArrayList<ArrayList<String>>());
		centros.get(1).add(new ArrayList<String>());
		centros.get(1).get(0).add("   cent 1 gru 2");
		centros.get(1).add(new ArrayList<String>());
		centros.get(1).get(1).add("   cent 2 gru 2");
		centros.get(1).add(new ArrayList<String>());
		centros.get(1).get(2).add("   cent 3 gru 2");

		centros.add(new ArrayList<ArrayList<String>>());
		centros.get(2).add(new ArrayList<String>());
		centros.get(2).get(0).add("   cent 1 gru 3");
		centros.get(2).add(new ArrayList<String>());
		centros.get(2).get(1).add("   cent 2 gru 3");
		centros.get(2).add(new ArrayList<String>());
		centros.get(2).get(2).add("   cent 3 gru 3");*/
	}
}
